<?php
		/*************************************************************************************************************************************
		This product was originally created by Matt Berntsen in October of 2005.
		I can be reached at <http://www.MattBerntsen.net>.
		It is licensed by the OSL v2.1 available in the included license.txt file and at <http://opensource.org/licenses/osl-2.1.php>.
		*************************************************************************************************************************************/

include_once("config.php");

/***************************************************************************
				Functions | Be VERY careful if you modiy them.
***************************************************************************/

// Pre: inTime as a avlid integer, and inMsg and inTarget are valid strings.
// Post: Generates code to wait inTime seconds, then redirect to Target. Displays inMsg w/ a link in case browser does not auto-redirect.
function redirect($inTime, $inMsg, $inTarget){
		// Input Validation
		if(gettype($inTarget) != 'string' || strlen($inTarget) == 0)
				return '';
		if(gettype($inTime)!= 'integer' || $inTime < 0)
				$inTime = 0;
		$inTarget = clean_str($inTarget);
		$rtn = '<meta http-equiv="REFRESH" content="'.$inTime.';url='.$inTarget.'"></HEAD><BODY>';
		if(gettype($inMsg) == 'string')
				$rtn = $rtn.'<p>'.$inMsg.'</p>';
		return $rtn.'<p>You will be automatically redirected in '.$inTime.' seconds. If you are not, please click <a href="'.$inTarget.'">here</a>.</p>';
}

// Pre: Connection to database has been established.
// Post: Adds user with the appropriate credentials if a user with the same username (login) does not already exist.
function add_user($in_urn, $in_pass, $in_status, $in_data){
	global $CONFIG;
	if(gettype($in_urn) == "string" && gettype($in_pass) == "string" && gettype($in_status) == "integer" && gettype($in_data) == "string"){
		$in_urn = clean_str($in_urn);
		$in_pass = clean_str($in_pass);
		$in_data = clean_str($in_data);
		$resource = mysql_query("SELECT user_login FROM ".$CONFIG['prefix']."User WHERE user_login=\"".strtolower($in_urn)."\";");
		if(!$resource)
			return false;
		if(mysql_num_rows($resource) == 0){
			mysql_query("INSERT INTO ".$CONFIG['prefix']."User (user_login, user_MD5, user_SHA1, user_status, user_data, user_enabled, user_active, user_last)
				values (\"".strtolower($in_urn)."\", \"".md5($in_pass.$CONFIG['salt'])."\", \"".sha1($in_pass.$CONFIG['salt'])."\", ".$in_status.
				", \"".$in_data."\", 1, 0, NOW());");
			return true;
		}
	}return false;
}

// Pre: Connection to database has been established.
// Post: User $in_usr is updated with new credentials.
function update_user($in_usr, $in_status, $in_enabled, $in_data){
	global $CONFIG;
	$in_usr = clean_str($in_usr);
	$in_data = clean_str($in_data);
	mysql_query("UPDATE ".$CONFIG['prefix']."User SET user_status = ".$in_status.", user_enabled = ".$in_enabled.", user_data = \"".
		$in_data."\" WHERE user_login = \"".strtolower($in_usr)."\"");
}

// Pre: Connection to database has been established.
// Post: If $in_usr exists in DB, user is removed.
function remove_user($in_usr){
	global $CONFIG;
	$in_usr = clean_str($in_usr);
	mysql_query('DELETE FROM '.$CONFIG['prefix'].'User WHERE user_login="'.strtolower($in_usr).'"');
}

// Pre: Connection to database has been established.
// Post: user $in_usr is logged in if they exist.
function login_user($in_usr, $ip){
	global $CONFIG;
	$in_usr = clean_str($in_usr);
	$ip = clean_str($ip);
	mysql_query('UPDATE '.$CONFIG['prefix'].'User SET user_active=1, user_last = NOW(), user_ip = "'.$ip.'" WHERE user_login="'.strtolower($in_usr).'"');
}

// Pre: Connection to database has been established.
// Post: User $in_usr is logged out.
function logout_user($in_usr){
	global $CONFIG;
	$in_usr = clean_str($in_usr);
	mysql_query('UPDATE '.$CONFIG['prefix'].'User SET user_active=0 WHERE user_login="'.strtolower($in_usr).'"');
}

// Pre: Connection to database has been established.
// If the password for $in_usr is $in_pass, return true. Else, return false.
function verify_pass($in_usr, $in_pass){
	global $CONFIG;
	$in_usr = clean_str($in_usr);
	$in_pass = clean_str($in_pass);
	$resource = mysql_query("SELECT user_login FROM ".$CONFIG['prefix']."User WHERE user_login='".strtolower($in_usr)."'
		AND user_MD5 = '". md5($in_pass.$CONFIG['salt'])."' AND user_SHA1 = '".sha1($in_pass.$CONFIG['salt'])."'");
	if($resource && mysql_num_rows($resource) > 0)
		return true;
	return false;
}

// Pre: Connection to database has been established.
// Post: Change the password for user $in_pass.
function change_pass($in_usr, $in_pass){
	global $CONFIG;
	$in_usr = clean_str($in_usr);
	$in_pass = clean_str($in_pass);
	mysql_query('UPDATE '.$CONFIG['prefix'].'User SET user_MD5="'.md5($in_pass.$CONFIG['salt']).'",
	 user_SHA1 = "'.sha1($in_pass.$CONFIG['salt']).'" WHERE user_login="'.strtolower($in_usr).'"');
}

// Pre: None
// Post: connects to server if possible, or displays applicable error message.
function db_connect(){
	global $CONFIG;
		$result = mysql_connect($CONFIG['dbserver'], $CONFIG['dbuser'], $CONFIG['dbpass']);
		if (!$result || !mysql_select_db($CONFIG['dbname']))
				die("Critical Error : Unable to connect to database<br><br>MySQL said: <b>".mysql_error()."</b>");
		return $result;
}

// Pre:  Connection to database has been established.
// Post: Returns 0 if logged out, or the value of user_status if logged in.
function get_status($in_usr, $in_ip){
	global $CONFIG;
	$in_usr = clean_str(strtolower($in_usr));
	$in_ip = clean_str($in_ip);
	$resource = mysql_query("SELECT user_status FROM ".$CONFIG['prefix']."User WHERE user_login='".$in_usr."'
		AND user_active=1 AND user_enabled=1 AND user_ip='".$in_ip."' AND user_last > (NOW()-".$CONFIG['timeout'].")");
	if($resource != false && mysql_num_rows($resource) > 0){
		$row = mysql_fetch_row($resource);
		return $row[0];
	}return 0;
}

// Pre: Connection to database has been established.
// Post: returns an array containing a list of the users contained in the DB. Returns false on error or no users.
function get_users(){
	global $CONFIG;
	$resource = mysql_query("SELECT user_login FROM ".$CONFIG[prefix]."User WHERE 1");
	if($resource != false && mysql_num_rows($resource) > 0){
		$row = mysql_fetch_row($resource);
		$result = array($row[0]);
		while($row = mysql_fetch_row($resource))
			array_push($result, $row[0]);
		return $result;
	}return false;
}

// Pre: Connection to database has been established.
// Post: get the user for $in_usr if it exists and return it in an array. Else return false.
function get_user_info($in_urn){
	global $CONFIG;
	$resource = mysql_query("SELECT user_status, user_data, user_enabled, user_active, user_last FROM ".$CONFIG['prefix']."User WHERE user_login = \"".
		clean_str(strtolower($in_urn))."\"");
	if($resource != false && mysql_num_rows($resource) > 0){
		$row = mysql_fetch_row($resource);
		return $row;
	}return false;
}

// Pre: None.
// Post: If $in_str is a valid string, all instances of the quotation mark characters (single and double) are removed. If illegal input, return false.
function clean_str($in_str){
	if(gettype($in_str) == "string")
		return str_replace("'", "", str_replace("\"", "", $in_str));
	return false;
}
?>